

/*
	------------------------------------------------------------
	possible binding(auto) by gameplay3d

	VIEW_MATRIX
	PROJECTION_MATRIX
	WORLD_VIEW_MATRIX
	VIEW_PROJECTION_MATRIX
	WORLD_VIEW_PROJECTION_MATRIX
	INVERSE_TRANSPOSE_WORLD_MATRIX
	INVERSE_TRANSPOSE_WORLD_VIEW_MATRIX
	CAMERA_WORLD_POSITION
	CAMERA_VIEW_POSITION
	MATRIX_PALETTE
	SCENE_AMBIENT_COLOR

	------------------------------------------------------------
	possible binding by hgimg4

	u_directionalLightColor
	u_directionalLightDirection

*/

// embedded objects
//#define MATERIAL_MODEL
//#define MATERIAL_SKY
#if !defined(MATERIAL_MODEL) && !defined(MATERIAL_SKY)
#define MATERIAL_MODEL
#endif

#ifdef MATERIAL_MODEL
#define LIGHTING
#endif

// flags
//#define LIGHTING
//#define COLORED
//#define TEXTURED
//#define SCREEN_GEOM
//#define SHADOW_GEOM
#define LIGHT_DIFFUSE
#define LIGHT_DIFFUSE_COLORED
//#define LIGHT_SPECULAR
//#define NO_NORMAL_EDGE_DIFFUSE

#if 0// for outer
#ifndef DIFFUSE_MULCOLOR
#define DIFFUSE_MULCOLOR			vec4(1)
#endif
#endif

#ifndef LIGHT_DIFFUSE_FACTOR_MIN
#define LIGHT_DIFFUSE_FACTOR_MIN	(0.8)
#endif

#ifndef LIGHT_DIFFUSE_FACTOR_POW
#define LIGHT_DIFFUSE_FACTOR_POW	(3.0)
#endif

#ifndef NO_NORMAL_EDGE_DIFFUSE
#define NORMAL_EDGE_DIFFUSE
#endif

#ifndef NORMAL_EDGE_COLOR
#define NORMAL_EDGE_COLOR			vec3(0.4, 0.4, 0.8)
#endif

#ifndef NORMAL_EDGE_STRENGTH
#define NORMAL_EDGE_STRENGTH		(1.0)
#endif

#ifndef NORMAL_EDGE_CLAMP_MIN
#define NORMAL_EDGE_CLAMP_MIN		(0.5)
#endif

#ifndef NORMAL_EDGE_CLAMP_MAX
#define NORMAL_EDGE_CLAMP_MAX		(1.0)
#endif

#define HEMISPHERE_LIGHT

#ifndef HEMISPHERE_LIGHT_COLOR_UP
#define HEMISPHERE_LIGHT_COLOR_UP	vec3(1.0, 0.6, 0.2)
#endif

#ifndef HEMISPHERE_LIGHT_COLOR_DOWN
#define HEMISPHERE_LIGHT_COLOR_DOWN	vec3(0.2, 0.6, 1.0)
#endif

#ifndef HEMISPHERE_LIGHT_STRENGTH
#define HEMISPHERE_LIGHT_STRENGTH	(0.1)
#endif

#if defined(SCREEN_GEOM) || defined(SHADOW_GEOM)
#define IS_MATERIAL_PASS			(0)
#else
#define IS_MATERIAL_PASS			(1)
#endif

#if (IS_MATERIAL_PASS && defined(LIGHTING)) || defined(SHADOW_GEOM)
#define PROCESS_NORMAL				(1)
#else
#define PROCESS_NORMAL				(0)
#endif

#define HDR_COMPRESS				(2.0)

#ifdef DISABLE_FOG
#define IS_FOG						(0)
#else
#define IS_FOG						(1)
#endif

#define DIRECTIONAL_LIGHT_COUNT		(1)
uniform vec3 u_directionalLightColor[DIRECTIONAL_LIGHT_COUNT];
uniform vec3 u_directionalLightDirection[DIRECTIONAL_LIGHT_COUNT];


