
///////////////////////////////////////////////////////////
// attributes

attribute vec3 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

///////////////////////////////////////////////////////////
// uniforms

uniform mat4 u_projectionMatrix;

///////////////////////////////////////////////////////////
// varyings

varying vec2 v_projCoord;
varying vec2 v_texCoord;
varying vec4 v_color;


void main()
{
	gl_Position = u_projectionMatrix * vec4(a_position, 1);

	v_projCoord = gl_Position.xy /gl_Position.w;
	v_texCoord = a_texCoord;
	v_color = a_color;
}
