
#include "pass_colloid_common.finc"

///////////////////////////////////////////////////////////
// uniforms

uniform sampler2D u_texture;
uniform vec4 u_colorClamp;
uniform float u_mixAlpha;

///////////////////////////////////////////////////////////
// varyings

varying vec2 v_projCoord;
varying vec2 v_texCoord;
varying vec4 v_color;

///////////////////////////////////////////////////////////
// pass

void main()
{
	vec2 colorUV = clamp(v_texCoord, vec2(0.001), vec2(0.999)) *vec2(2.0 /3.0, 1.0);
	vec2 diffUV = clamp(v_texCoord +vec2(0.005, 0.0), vec2(0.01), vec2(0.99)) *vec2(1.0 /3.0, 0.5) + vec2(2.0 /3.0, 0.5);
	vec4 color = texture( u_texture, colorUV );
	vec4 diff = texture( u_texture, diffUV );
	vec4 clamped = min( color, u_colorClamp );
	vec4 resolved = max( clamped, diff );
	vec4 outColor = mix( color, resolved, u_mixAlpha );
	gl_FragColor = outColor;
}

