#ifdef OPENGL_ES
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#endif

///////////////////////////////////////////////////////////
// uniforms

uniform sampler2D u_texture;

///////////////////////////////////////////////////////////
// varyings

varying vec2 v_projCoord;
varying vec2 v_texCoord;
varying vec2 v_texCoordScr;
varying vec2 v_texCoordSdw;
varying vec4 v_color;

#define FRAGMENT_SHADER
#include "colloid_func.inc"

void main()
{
	// konstants
	//float fovyTan = SCREEN_FOVY_TAN;
	float fovyTan = SCREEN_HALF_FOVY_TAN;

	// gather textures
	vec4 scrTexel = texture( u_texture, v_texCoordScr );
	vec4 sdwTexel = texture( u_texture, v_texCoordSdw );

	float viewNLD = decompress16( scrTexel.xy );
	float viewDepth = nld2depth( viewNLD );

	float shadowNLD = decompress16( sdwTexel.xy );
	float shadowDepth = sdwNld2depth( shadowNLD );
	vec2 viewNormal = sdwTexel.zw;

	// view pos
	vec3 viewPos;
	viewPos.xy = v_projCoord.xy * vec2( SCREEN_ASPECT, 1.0 ) * SCREEN_HALF_FOVY_TAN * viewDepth;
	viewPos.z = viewDepth;

	// determine color
	vec4 outColor = vec4(1.0);

	// test
#if 1
	//outColor.rgb = vec3( viewPos.xyz ) * 0.1;
	//outColor.rgb = vec3(viewDepth) * 0.1;// depth vis
	//outColor.rgb = vec3(viewNLD);// depth vis

	// fog
	outColor.rgb = vec3( 1.0, 0.0, 0.0 );
	outColor.a = clamp( viewNLD *10.0, 0.0, 1.0 ) *0.2;
#endif

	gl_FragColor = outColor;
}

