
///////////////////////////////////////////////////////////
// attributes

attribute vec3 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

///////////////////////////////////////////////////////////
// uniforms

uniform mat4 u_projectionMatrix;

///////////////////////////////////////////////////////////
// varyings

varying vec2 v_projCoord;
varying vec2 v_texCoord;
varying vec2 v_texCoordScr;
varying vec2 v_texCoordSdw;
varying vec4 v_color;


void main()
{
	gl_Position = u_projectionMatrix * vec4(a_position, 1);

	vec2 texMin = vec2( 0.002, 0.002 );

	v_projCoord = gl_Position.xy /gl_Position.w;
	v_texCoord = a_texCoord;
	v_texCoordScr = max( texMin, ( v_texCoord.xy * 0.5 ) + vec2( 0.0, 0.0 ) );
	v_texCoordSdw = max( texMin, ( v_texCoord.xy * 0.5 ) + vec2( 0.0, 0.5 ) );
	v_color = a_color;
}
